#include <tads.h>

main(args)
{
    f(aObj, bObj);
    f(bObj, aObj);
    f(cObj, dObj);
    f(dObj, cObj);
    f(aObj);
    f(bObj);
    f(cObj);
    f();
    f(aObj, 1);
    f(aObj, bObj, 2);

    local x = f;
    x(cObj, dObj);

    local v = new Vector(5);
    v.append('One');
    v.append('Two');
    local s = 'Test String';
    local l = ['Test', 'List'];

    g(s, l);
    g(s, v, v);
    g(l, v, v);
}

g(String s, List l)
{
    "g(String(<<s>>), List)\n";
}
g(String s, Vector v, Vector w)
{
    "g(String(<<s>>), Vector, Vector)\n";
}
g(List l, Vector v, Vector w)
{
    "g(List, Vector, Vector)\n";
}

class A: object
;

class B: A
;

class C: B
;

class D: B
;

aObj: A;
bObj: B;
cObj: C;
dObj: D;

f(A x, A y)
{
    "f(A,A)\n";
}

f(B x, B y)
{
    "f(B,B)\n";
}

f(C x, D y)
{
    "f(C,D)\n";
}

f(B b)
{
    "f(B)\n";
}

f(x) multimethod
{
    "f(x)\n";
}

f() multimethod
{
    "f()\n";
}

f(A a, [args])
{
    "f(A,...)\n";
}

